/*
 * Streamtastic Streamripper Frontend
 * Copyright 2008 Andreas Kuehntopf <andreas@kuehntopf.org>
 * Copyright 2008-2010 Michael Lippold <thabird@free.fr>
 * Copyright 2008-2011 Joachim Lippold <mailToJoeAtIcq@icqmail.com>
 * 
 * This file is part of Streamtastic.
 *
 * Streamtastic is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Streamtastic is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Streamtastic.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.kuehntopf.streamtastic.core.config.validators;

import java.io.FileNotFoundException;

import org.kuehntopf.streamtastic.core.config.Validator;
import org.kuehntopf.streamtastic.utils.Command;
import org.kuehntopf.streamtastic.utils.Player;

/**
 * @author Joachim Lippold <mailToJoeAtIcq@icqmail.com>
 *
 */
public class PlayerCmdOptsValidator implements Validator {

    private final static Command PLAYER_TEST_COMMAND;
    static
    {
        Command playerCmd = null;
        try
        {
            playerCmd = new PlayerTestCommand();
        }
        catch (FileNotFoundException e) { e.printStackTrace(); }
        PLAYER_TEST_COMMAND = playerCmd;
    }

    /* (non-Javadoc)
     * @see org.kuehntopf.streamtastic.core.config.Validator#isValid(java.lang.Object)
     */
    public boolean isValid(Object value)
    {
        // TODO validate player comand line args
        try
        {
            PLAYER_TEST_COMMAND.setOptionString((String) value);
            PLAYER_TEST_COMMAND.set(Player.OPTION_URL, "test");
        }
        catch (Exception e)
        {
            return false;
        }
        return true;
    }
}

class PlayerTestCommand extends Command {
    public PlayerTestCommand() throws FileNotFoundException
    {
        super(null, "", false);
    }
}