/*
 * Streamtastic Streamripper Frontend
 * Copyright 2008 Andreas Kuehntopf <andreas@kuehntopf.org>
 * 
 * This file is part of Streamtastic.
 *
 * Streamtastic is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Streamtastic is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Streamtastic.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.kuehntopf.streamtastic.gui.components;

import javax.swing.Action;
import javax.swing.JTable;
import javax.swing.RowSorter;
import javax.swing.table.TableColumnModel;
import javax.swing.table.TableModel;
import org.kuehntopf.streamtastic.core.Station;

/**
 * @author Joachim Lippold <mailToJoeAtIcq@icqmail.com>
 *
 */
public class FavoritesPanel extends javax.swing.JPanel {

    /** Creates new form FavoritesPanel */
    public FavoritesPanel() {
        initComponents();
    }

    public Station getSelectedFavorite()
    {
        int selPos = favoritesTable.getSelectedRow();
        if (selPos == -1)
            return null;
        return (Station) favoritesTable.getValueAt(selPos, 0);
    }

    public JTable initTable(TableModel model, TableColumnModel columnModel, RowSorter rowsorter)
    {
        favoritesTable.setAutoCreateColumnsFromModel(false);
        favoritesTable.setModel(model);
        favoritesTable.setColumnModel(columnModel);
        favoritesTable.setRowSorter(rowsorter);

        return favoritesTable;
    }

    public void setQuickAddAction(Action quickAddAction)
    {
        addFavTextField.addActionListener(quickAddAction);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        addFavLabel = new javax.swing.JLabel();
        addFavTextField = new javax.swing.JTextField();
        scrollPane = new javax.swing.JScrollPane();
        favoritesTable = new javax.swing.JTable();

        setLayout(new java.awt.GridBagLayout());

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/kuehntopf/streamtastic/resources/i18n/streamtastic"); // NOI18N
        addFavLabel.setText(bundle.getString("FAVS_QUICKADD")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 1, 4, 5);
        add(addFavLabel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 4, 0);
        add(addFavTextField, gridBagConstraints);

        favoritesTable.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        scrollPane.setViewportView(favoritesTable);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(scrollPane, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel addFavLabel;
    private javax.swing.JTextField addFavTextField;
    private javax.swing.JTable favoritesTable;
    private javax.swing.JScrollPane scrollPane;
    // End of variables declaration//GEN-END:variables

}
