/*
 * Streamtastic Streamripper Frontend
 * Copyright 2008 Andreas Kuehntopf <andreas@kuehntopf.org>
 * 
 * This file is part of Streamtastic.
 *
 * Streamtastic is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Streamtastic is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Streamtastic.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.kuehntopf.streamtastic.gui.models;

import java.util.List;
import java.util.Vector;

import javax.swing.AbstractListModel;

import org.kuehntopf.streamtastic.utils.SelectionMaintainer;

/**
 * @author Joachim Lippold <mailToJoeAtIcq@icqmail.com>
 *
 */
public class GenreListModel extends AbstractListModel {
    private List<String> genreList = new Vector<String>();
    private SelectionMaintainer<String> selectionMaintainer= new SelectionMaintainer<String>() {
        @Override
        public void fireReplaced(int start, int end)
        {
            fireContentsChanged(GenreListModel.this, start, end);
        }
        @Override
        public void fireRemoved(int start, int end)
        {
            fireIntervalRemoved(GenreListModel.this, start, end);
        }
        @Override
        public void fireAdded(int start, int end)
        {
            fireIntervalAdded(GenreListModel.this, start, end);
        }
    };

    public Object getElementAt(int index)
    {
        return genreList.get(index);
    }

    public int getSize()
    {
        return genreList.size();
    }

    public void setGenres(List<String> genres, int selectedIndex)
    {
        selectionMaintainer.updateList(genreList, genres, selectedIndex);
    }

}