/*
 * Streamtastic Streamripper Frontend
 * Copyright 2008 Andreas Kuehntopf <andreas@kuehntopf.org>
 * Copyright 2008-2010 Michael Lippold <thabird@free.fr>
 * Copyright 2008-2011 Joachim Lippold <mailToJoeAtIcq@icqmail.com>
 * 
 * This file is part of Streamtastic.
 *
 * Streamtastic is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Streamtastic is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Streamtastic.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.kuehntopf.streamtastic.gui.models;

import java.awt.Container;
import java.awt.event.HierarchyEvent;
import java.awt.event.HierarchyListener;

/**
 * @author Joachim Lippold <mailToJoeAtIcq@icqmail.com>
 *
 */
public abstract class OptionModel implements HierarchyListener {

    private boolean wasShowing = false;

    public OptionModel()
    {
        getDisplay().addHierarchyListener(this);
    }

    public abstract void readFromBaseModel();
    public abstract void writeToBaseModel();
    public abstract void applyChanges();
    public abstract void revertChanges();
    public abstract void loadDefaults();
    public abstract Container getDisplay();

    public void hierarchyChanged(HierarchyEvent e)
    {
        if ((e.getChangeFlags() & HierarchyEvent.SHOWING_CHANGED)==0) return;

        if (getDisplay().isShowing()) readFromBaseModel();
        else if (wasShowing) writeToBaseModel();

        wasShowing = getDisplay().isShowing();
    }

}
