/*
 * Streamtastic Streamripper Frontend
 * Copyright 2008 Andreas Kuehntopf <andreas@kuehntopf.org>
 * Copyright 2008-2010 Michael Lippold <thabird@free.fr>
 * Copyright 2008-2011 Joachim Lippold <mailToJoeAtIcq@icqmail.com>
 * 
 * This file is part of Streamtastic.
 *
 * Streamtastic is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Streamtastic is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Streamtastic.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.kuehntopf.streamtastic.gui.views;

import java.awt.BorderLayout;
import java.awt.Insets;

import javax.swing.Icon;
import javax.swing.JToolBar;

/**
 * @author Joachim Lippold <mailToJoeAtIcq@icqmail.com>
 * 
 */
public abstract class ToolbarView extends View {

    private JToolBar toolbar;

    /**
     * 
     */
    public ToolbarView(String title, Icon headerIcon, Icon displayIcon)
    {
        super(title, headerIcon, displayIcon);

        toolbar = new JToolBar();
        toolbar.setMargin(new Insets(1,0,1,0));
        toolbar.setFloatable(false);
        toolbar.setOpaque(false);
        this.add(toolbar, BorderLayout.SOUTH);
    }

    @Override
    public void init()
    {
        super.init();
        initToolbar(toolbar);
    }

    protected abstract void initToolbar(final JToolBar toolbar);
}
